
# 11 "toplevel/g_toplevel.mlg"
 
open Pcoq
open Pcoq.Prim
open Tok
open Util
open Vernacexpr

(* Vernaculars specific to the toplevel *)
type vernac_toplevel =
  | VernacBackTo of int
  | VernacDrop
  | VernacQuit
  | VernacControl of vernac_control
  | VernacShowGoal of { gid : int; sid: int }
  | VernacShowProofDiffs of bool

module Toplevel_ : sig
  val vernac_toplevel : vernac_toplevel option Entry.t
end = struct
  let gec_vernac s = Entry.create ("toplevel:" ^ s)
  let vernac_toplevel = gec_vernac "vernac_toplevel"
end

open Toplevel_

let err () = raise Stream.Failure

let test_show_goal =
  Pcoq.Entry.of_parser "test_show_goal"
    (fun _ strm ->
      match stream_nth 0 strm with
      | IDENT "Show" ->
          (match stream_nth 1 strm with
          | IDENT "Goal" ->
            (match stream_nth 2 strm with
              | NUMERAL _ -> ()
              | _ -> err ())
          | _ -> err ())
      | _ -> err ())



let _ = let () =
        Pcoq.grammar_extend vernac_toplevel None
        (Some
        (Gramlib.Gramext.First), [(None, None,
                                  [Extend.Rule
                                   (Extend.Next (Extend.Stop,
                                                (Extend.Aentry Pvernac.Vernac_.main_entry)),
                                   (fun cmd loc -> 
# 66 "toplevel/g_toplevel.mlg"
                match cmd with
              | None -> None
              | Some v -> Some (VernacControl v) 
                                                   ));
                                  Extend.Rule
                                  (Extend.Next (Extend.Next (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Stop,
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Show"))))),
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Proof"))))),
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Diffs"))))),
                                                            (Extend.Aopt (Extend.Arules 
                                                            [Extend.Rules 
                                                            (Extend.NextNoRec 
                                                            (Extend.Stop,
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("removed"))))),
                                                            (fun _ loc -> 
                                                            
# 63 "toplevel/g_toplevel.mlg"
                                                                                         () 
                                                            ))]))),
                                               (Extend.Atoken (Tok.PKEYWORD (".")))),
                                  (fun _ removed _ _ _ loc -> 
# 64 "toplevel/g_toplevel.mlg"
          Some (VernacShowProofDiffs (removed <> None)) 
                                                              ));
                                  Extend.Rule
                                  (Extend.Next (Extend.Next (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Next 
                                                            (Extend.Stop,
                                                            (Extend.Aentry test_show_goal)),
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Show"))))),
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Goal"))))),
                                                            (Extend.Aentry natural)),
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("at"))))),
                                                            (Extend.Aentry natural)),
                                               (Extend.Atoken (Tok.PKEYWORD (".")))),
                                  (fun _ sid _ gid _ _ _ loc -> 
# 62 "toplevel/g_toplevel.mlg"
            Some (VernacShowGoal {gid; sid}) 
                                                                ));
                                  Extend.Rule
                                  (Extend.Next (Extend.Next (Extend.Next 
                                                            (Extend.Stop,
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("BackTo"))))),
                                                            (Extend.Aentry natural)),
                                               (Extend.Atoken (Tok.PKEYWORD (".")))),
                                  (fun _ n _ loc -> 
# 59 "toplevel/g_toplevel.mlg"
          Some (VernacBackTo n) 
                                                    ));
                                  Extend.Rule
                                  (Extend.Next (Extend.Next (Extend.Stop,
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Quit"))))),
                                               (Extend.Atoken (Tok.PKEYWORD (".")))),
                                  (fun _ _ loc -> 
# 57 "toplevel/g_toplevel.mlg"
                               Some VernacQuit 
                                                  ));
                                  Extend.Rule
                                  (Extend.Next (Extend.Next (Extend.Stop,
                                                            (Extend.Atoken (Tok.PIDENT (Some
                                                            ("Drop"))))),
                                               (Extend.Atoken (Tok.PKEYWORD (".")))),
                                  (fun _ _ loc -> 
# 56 "toplevel/g_toplevel.mlg"
                               Some VernacDrop 
                                                  ))])])
        in ()


# 74 "toplevel/g_toplevel.mlg"
 

let vernac_toplevel pm =
  Pvernac.Unsafe.set_tactic_entry pm;
  vernac_toplevel



